<template>
  <ob-form
      :form-data="formData"
      :form-model="formModel"
      :is-read-only="!isNew"
      :is-loading="isShowLoader"
      @submit="onSubmitHandler"
      cancelText="Отменить"
      data-qa="formFileLoaderBP"
  >
    <div class="row">
      <div class="col-xs-12">
        <div class="form-group">
          <div class="form-group__title">Наименование</div>
          <ob-input
            label="Наименование загрузки"
            v-model="formData.summary"
            placeholder="Укажите"
            :disabled="!isNew"
            :required="true"
            @input="resetError"
            data-qa="inputSummaryBP"
          />
        </div>
      </div>
      <div class="col-xs-12" v-if="type!=='FIXED_VALUES'">
        <div class="form-group">
          <div class="form-group__title">Коэффициент доверия</div>
          <div class="form-group__label">При значении, равном 1, предыдущие данные учитываться не будут</div>
          <ob-input
              label="Коэф-т доверия (от 0 до 1)"
              type="money:2"
              v-model="formData.confidenceKoef"
              :isConvertMoney="false"
              :is-valid="isСonfidenceKoefValid ? null : false"
              validation-message="Введенное число не соответствует условиям"
              @input="resetError"
              data-qa="inputConfidenceKoefBP"
          />
        </div>
      </div>
      <div class="col-xs-12" v-if="type==='FIXED_VALUES'">
        <div class="form-group">
          <div class="form-group__title">Тип загружаемых локаций</div>
            <ObControlGroup
                :items="groupItems"
                v-model="formData.typeLocations"
                theme="light"
                height="slim"
                data-qa="uploaderFileBP"
            />
        </div>
      </div>
      <div class="col-xs-12">
        <div class="form-group">
          <div class="form-group__title">{{ texts[type] }}</div>
          <div class="form-group__label">Подойдут форматы XLS, XLSX, CSV</div>
          <ObUploader
              class="d-none"
              ref="uploader"
              :upload-method="uploadMethod"
              @change="onUpload($event)"
              @removeFile="onRemoveFile"
              data-qa="uploaderFileBP"
          />
        </div>
      </div>
    </div>

    <transition name="fadeIn">
      <ObAlert
          v-if="error"
          :text="error"
          class="alert-error"
          theme="danger"
          icon="alert"
          :hide-close-button="true"
      />
    </transition>

  </ob-form>
</template>

<script>
import api from '@/api';
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObAlert from "common-components/src/obComponents/obAlert";
import ObControlGroup from "common-components/src/obComponents/obControlGroup";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import ObUploader from 'common-components/src/obComponents/obUploader';
import {required, requiredIf} from "vuelidate/lib/validators";

export default {
  name: "BasePriceImportModalForm",
  components: {
    ObForm,
    ObInput,
    ObUploader,
    ObAlert,
    ObControlGroup,
  },
  mixins: [FormValidationMixin, dropdownEvents],
  props: {
    selectedData: {
      type: Object,
      default: () => {}
    },
    type: {
      type: String,
      default: () => ''
    },
  },
  data () {
    return {
      error: '',
      isShowLoader: false,
      formData: {
        summary: null,
        confidenceKoef: null,
        fileUuid: null,
        typeLocations: 'REFERENCE_POSITION',
      },
      uploader: {
        files: [],
        isHide: false
      },
      groupItems: [
        {
          label: 'Опорные точки',
          value: 'REFERENCE_POSITION',
        },
        {
          label: 'ЖД. станции',
          value: 'RAILWAY_STATION',
        },
      ],
      texts: {
        "ORDERS": "Файл заказов",
        "EXPERT_VALUES": "Файл экспертных значений",
        "FIXED_VALUES": "Файл фиксированных значений"
      },
    }
  },
  watch: {
    'formData.fileUuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  computed: {
    formModel() {
      return {
        summary: {
          value: '',
          validator: {
            required
          }
        },
        confidenceKoef: {
          type: 'number',
          value: 1,
          validator: {
            required: requiredIf(() => this.type!=='FIXED_VALUES'),
            checkLocation: {
              method: (value) => {
                if(value){
                  let koeff = parseFloat(value);
                  if(koeff < 0 || koeff > 1){
                    return false;
                  }
                }
                return true;
              },
            }
          }
        },
        fileUuid: {
          value: '',
          validator: {
            required
          }
        },
        typeLocations: {
          value: 'REFERENCE_POSITION',
          validator: {
            required: requiredIf(() => this.type==='FIXED_VALUES'),
          }
        }
      }
    },
    isNew() {
      return !this.formData.uuid;
    },
    isСonfidenceKoefValid() {
      if(this.formData.confidenceKoef){
        let koeff = parseFloat(this.formData.confidenceKoef);
        if(koeff < 0 || koeff > 1){
          return false;
        }
      }
      return true;
    },
    uploadMethod () {
      return api.files.postFile
    }
  },
  methods: {
    async onSubmitHandler() {
      let that = this;
      let data = {...this.formData};
      let file = this.uploader.files[0];
      let extensions = ["xls", "xlsx", "csv"];
      if (file && file.isUploaded === true) {
        let ext = file.file.name.split('.').pop().toLowerCase();
        if ( !extensions.includes( ext ) ) {
          this.error = 'Пожалуйста загрузите файл с расширением из списка: "xls, xlsx, csv"';
          return false;
        }
        data.fileUuid = file.uuid;
      } else {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки файла'
        });
        return false;
      }

      let params = {
        type: that.type,
        file_uuid: data.fileUuid,
        summary: data.summary,
        confidence_koef: data.confidenceKoef,
        type_locations: data.typeLocations,
      }
      this.isShowLoader = true;
      try {
        let response = await api.base_prices_data_import.loadFile(params);
        this.isShowLoader = false;
        if (response) {
          this.onRemoveFile();
          this.$emit("save", { formData: data, model: this.formModel });
        }
      } catch (e) {
        this.isShowLoader = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка импорта файла'});
        this.error = 'Ошибка импорта файла';
      }
    },
    onUpload(files) {
      this.resetError();
      this.uploader.files = [ ...files ]
      this.formData.fileUuid = this.uploader.files[0]?.uuid || '';
    },
    resetError() {
      this.error = '';
    },
    onRemoveFile() {
      const _tmp = {
        files: [],
        isHide: false
      }
      this.uploader = { ..._tmp }
    },
    close () {
      this.onRemoveFile();
      this.$emit('close')
    },
  }
};
</script>

<style lang="scss">
@import "~common-components/src/static/css/mixins";
.form-group {
  justify-content: space-between;
  align-self: flex-start;
  margin-bottom: 20px;

  &__title {
    @include font-mixin(20px, 28px, 700, #191E32, 0.4px);
    margin-bottom: 10px;
  }

  &__label {
    @include font-mixin(14px, 18px, 400, #737682, 0.2px);
    margin-bottom: 15px;
  }

  .input-group .input{
    color: $cobalt-black;
  }
}
</style>